//+------------------------------------------------------------------+
//|                                              VininI_MACD_MTF.mq4 |
//|                     Copyright  2011, Victor Niclolaev aka Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Victor Niclolaev aka Vinin"
#property link      "vinin@mail.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
//--- input parameters
extern int       TimeFrame=0;          //  
extern int       FastEma=12;           
extern int       SlowEma=26;
extern int       SignalSMA=9;
extern int       price=PRICE_CLOSE;
extern bool      RedRaw=false;         //          
//--- buffers
double MACD[];
double SIGNAL[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MACD);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,SIGNAL);
   if (TimeFrame<Period()) TimeFrame=Period();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  i,  pos, counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars-1;
   
   if (RedRaw && !(limit>1)) limit=iBarShift(NULL, 0, iTime(NULL, TimeFrame, 1), true);
   
   for (i=limit;i>=0;i--) {
      pos=iBarShift(NULL, TimeFrame, Time[i], true);
      MACD[i]  =iMACD(NULL, TimeFrame, FastEma, SlowEma, SignalSMA, price, MODE_MAIN,   pos);
      SIGNAL[i]=iMACD(NULL, TimeFrame, FastEma, SlowEma, SignalSMA, price, MODE_SIGNAL, pos);
   }

   return(0);
  }
//+------------------------------------------------------------------+